package br.ufsc.uid2uml.UIDElements;


/**
 * @author Patricia Vilain
 */
public class DataItem extends UIDElement {
	
	public static final int SINGLE = 1;
	public static final int SET = 2;
	private String name;
	private String domain;
	private int type = SINGLE;
	private int cardinalityMin;
	private int cardinalityMax;
	
	/**
	 * O item de dado e' criado, por default, como um item de dado simples (single).
	 */
	public DataItem (String name){
		this.name = name;
		this.type = SINGLE;
		cardinalityMin = 1;
		cardinalityMax = 1;
	}

	/**
	 * O item de dado e' criado, por default, como um item de dado simples (single).
	 */
	public DataItem (String name, String domain){
		this.name = name;
		this.domain = domain;
		this.type = SINGLE;
		cardinalityMin = 1;
		cardinalityMax = 1;
	}

	public String getDomain() {
		return domain;
	}

	public String getName() {
		return name;
	}

	public int getCardinalityMax() {
		return cardinalityMax;
	}

	public void setCardinalityMax(int cardinalityMax) {
		this.cardinalityMax = cardinalityMax;
	}

	public int getCardinalityMin() {
		return cardinalityMin;
	}

	public void setCardinalityMin(int cardinalityMin) {
		this.cardinalityMin = cardinalityMin;
	}

	public boolean isSet() {
		return this.type == SET;
	}
	
	public boolean isOptional() {
		return this.cardinalityMin == 0;
	}

	public void definesAsSet() {
		this.type = SET;
	}
}
