package br.ufsc.uid2uml.UIDElements;
/**
 * @author Patricia Vilain
 */
import java.util.*;




//TIREI OS METODOS DE REMOVE...


public class UID {
	
	private String id;
	private String name;
	private Vector<String> setSourceUIDs;
	private InitialState initialState;
	private Vector<AbstractState> setStates;
	private Vector<Transition> setTransitions;
	private List<Precondition> listPreconditions;
	private List<Poscondition> listPosconditions;
	private List<TextualNote> listTextualNotes;
	private Vector<UIDCall> setUIDCalls;


	public UID (String id, String name){
		this.id = id;
		this.name = name;
		this.setStates = new Vector<AbstractState> ();
		this.setTransitions = new Vector<Transition> ();
		this.listPreconditions = new ArrayList<Precondition> ();
		this.listPosconditions = new ArrayList<Poscondition> ();
		this.listTextualNotes = new ArrayList<TextualNote> ();
		this.setUIDCalls = new Vector<UIDCall>();
	}

	public void insertInitialState (String idInitialState){
		if (this.initialState != null)
			throw new UIDException (UIDException.EXISTING_STATE, 
			"There is already a initial state");
		else {
			this.initialState = new InitialState(idInitialState);
			this.setStates.add(this.initialState);
			//Insere o estado inicial no vetor de estados para simplificar 
			//as opera��es a serem realizadas sob os estados.
		}
	}

	public void insertState (String idState){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				throw new UIDException (UIDException.EXISTING_STATE, 
				"There is already a state with this id");
			}	
		}
		State state = new State(idState);
		this.setStates.add(state);
	}
	
	public void insertUIDCall(String idUIDCall, String name) {
		for (int i = 0; i < this.setUIDCalls.size(); i++) {
			UIDCall UC = this.setUIDCalls.elementAt(i);
			if (UC.getId().equals(idUIDCall)) {
				throw new UIDException(UIDException.EXISTING_UID_CALL,
				"There is already a UID call with this id");
				}
			}
		UIDCall UC = new UIDCall(idUIDCall, name);
		this.setUIDCalls.add(UC);
	}
	
	public void insertInputDataItem (String idState, InputDataItem dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputDataItem(dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertInputDataItemInStructure (String idState, String nameStructure, InputDataItem dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputDataItemInStructure(nameStructure,dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	} 
	
	public void insertInputOptionalDataItem(String idState,
			InputOptionalDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputOptionalDataItem(dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");
	}

	public void insertInputStructure (String idState, InputStructure structure){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputStructure(structure);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertInputOptionalDataItemInStructure(String idState,
			String nameStructure, InputOptionalDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputOptionalDataItemInStructure(nameStructure,
						dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");
	}

	public void insertInputStructureInStructure (String idState, String nameStructure, InputStructure structure){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputStructureInStructure(nameStructure,structure);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	} 
	
	public void insertOutputDataItem (String idState, OutputDataItem dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertOutputDataItem(dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertOutputDataItemInStructure (String idState, String nameStructure, OutputDataItem dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertOutputDataItemInStructure(nameStructure,dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	} 
	
	public void insertOutputStructure (String idState, OutputStructure structure){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertOutputStructure(structure);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertOutputStructureInStructure (String idState, String nameStructure, OutputStructure structure){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertOutputStructureInStructure(nameStructure,structure);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	} 
	
	public void insertInputORDataItem (String idState, InputORDataEntry dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputORDataItem(dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertInputXORDataItem (String idState, InputXORDataEntry dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputXORDataItem(dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertInputEnumeratedData(String idState, InputEnumeratedData dataItem){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertInputEnumeratedData(dataItem);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertOptionInInputEnumeratedData(String idState, String nameEnumeratedData, String option){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertOptionInInputEnumeratedData(nameEnumeratedData,option);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertSelectionInInputEnumeratedData(String idState, String nameEnumeratedData, int min, int max){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertSelectionInInputEnumeratedData(nameEnumeratedData,min,max);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertText (String idState, String idText, String text){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.insertText(idText,text);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void defineTextAsOptional (String idState, String idText){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)){
				state.defineTextAsOptional(idText);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertTransitionFromStateToState (String idSourceState, String idTargetState,
			String idTransition){
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState!=null && targetState!=null){
			Transition transition = new Transition (idTransition, sourceState, targetState);
			sourceState.insertOutgoingTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		}
		else
			throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
		
	public void insertTransitionFromOutputDataItemToState (String idSourceState, String nameDataItem, 
			String idTargetState, String idTransition){
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState!=null && targetState!=null){
			DataItem dataItem = sourceState.getDataItem (nameDataItem);
			if (dataItem instanceof OutputDataItem){
				Transition transition;
				if (dataItem.getCardinalityMax()>dataItem.getCardinalityMin())
					transition = new TransitionFromSet (idTransition, dataItem, targetState);
				else
					transition = new Transition (idTransition, dataItem, targetState);
				((OutputDataItem)dataItem).insertTransition(transition);
				targetState.insertIncomingTransition(transition);
				this.setTransitions.add(transition);
			}
			else 
				throw new UIDException (UIDException.NOT_EXISTING_DATA_ITEM, 
				"There is no output data item with this name");
		}
		else
			throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertTransitionFromOutputDataItemInStructureToState (String idSourceState, String nameDataItem, 
			String nameStructure, String idTargetState, String idTransition){
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState!=null && targetState!=null){
			DataItem dataItem = sourceState.getDataItemInStructure (nameDataItem,nameStructure);
			if (dataItem instanceof OutputDataItem){
				Transition transition;
				if (dataItem.getCardinalityMax()>dataItem.getCardinalityMin())
					transition = new TransitionFromSet (idTransition, dataItem, targetState);
				else
					transition = new Transition (idTransition, dataItem, targetState);
				((OutputDataItem)dataItem).insertTransition(transition);
				targetState.insertIncomingTransition(transition);
				this.setTransitions.add(transition);
			}
			else 
				throw new UIDException (UIDException.NOT_EXISTING_DATA_ITEM, 
				"There is no output data item with this name");
		}
		else
			throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertTransitionFromOutputStructureToState (String idSourceState, String nameStructure, 
			String idTargetState, String idTransition){
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState!=null && targetState!=null){
			Structure structure = sourceState.getStructure(nameStructure);
			if (structure instanceof OutputStructure){
				Transition transition;
				if (structure.getCardinalityMax()>structure.getCardinalityMin()|| structure.getCardinalityMax()==-1)
					transition = new TransitionFromSet (idTransition, structure, targetState);
				else
					transition = new Transition (idTransition, structure, targetState);
				((OutputStructure)structure).insertTransition(transition);
				targetState.insertIncomingTransition(transition);
				this.setTransitions.add(transition);
			}
			else 
				throw new UIDException (UIDException.NOT_EXISTING_STRUCTURE, 
				"There is no output structure item with this name");
		}
		else
			throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
		
	public void insertTransitionFromOutputStructureInStructureToState (String idSourceState, String nameStructure, 
			String nameExternalStructure, String idTargetState, String idTransition){
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState!=null && targetState!=null){
			Structure structure = sourceState.getStructureInStructure (nameStructure,nameExternalStructure);
			Transition transition;
			if (structure instanceof OutputStructure){
				if (structure.getCardinalityMax()>structure.getCardinalityMin()|| structure.getCardinalityMax()==-1)
					transition = new TransitionFromSet (idTransition, structure, targetState);
				else
					transition = new Transition (idTransition, structure, targetState);
				((OutputStructure)structure).insertTransition(transition);
				targetState.insertIncomingTransition(transition);
				this.setTransitions.add(transition);
			}
			else 
				throw new UIDException (UIDException.NOT_EXISTING_STRUCTURE, 
				"There is no output structure item with this name");
		}
		else
			throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertTransitionFromStateToAnotherUID (String idSourceState, String nameTargetUID,
			String idTransition){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)){
				Transition transition = new Transition (idTransition, state, nameTargetUID);
				state.insertOutgoingTransition(transition);
				this.setTransitions.add(transition);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
			"There is no state with this id");
	}	
	
	public void insertTransitionFromOutputDataItemToAnotherUID (String idSourceState, String nameDataItem, 
			String nameTargetUID, String idTransition){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)){
				DataItem dataItem = state.getDataItem (nameDataItem);
				if (dataItem instanceof OutputDataItem){
					Transition transition;
					if (dataItem.getCardinalityMax()>dataItem.getCardinalityMin())
						transition = new TransitionFromSet (idTransition, dataItem, nameTargetUID);
					else
						transition = new Transition (idTransition, dataItem, nameTargetUID);
					((OutputDataItem)dataItem).insertTransition(transition);
					this.setTransitions.add(transition);
					return;				
				}
				else 
					throw new UIDException (UIDException.NOT_EXISTING_DATA_ITEM, 
					"There is no output data item with this name");
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertTransitionFromOutputDataItemInStructureToAnotherUID (String idSourceState, String nameDataItem, 
			String nameStructure, String nameTargetUID, String idTransition){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)){
				DataItem dataItem = state.getDataItemInStructure (nameDataItem,nameStructure);
				if (dataItem instanceof OutputDataItem){
					Transition transition;
					if (dataItem.getCardinalityMax()>dataItem.getCardinalityMin())
						transition = new TransitionFromSet (idTransition, dataItem, nameTargetUID);
					else
						transition = new Transition (idTransition, dataItem, nameTargetUID);
					((OutputDataItem)dataItem).insertTransition(transition);
					this.setTransitions.add(transition);
					return;
				}
				else 
					throw new UIDException (UIDException.NOT_EXISTING_DATA_ITEM, 
					"There is no output data item with this name");
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}

	public void insertTransitionFromOutputStructureToAnotherUID (String idSourceState, String nameStructure, 
			String nameTargetUID, String idTransition){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)){
				Structure structure = state.getStructure(nameStructure);
				if (structure instanceof OutputStructure){
					Transition transition;
					if (structure.getCardinalityMax()>structure.getCardinalityMin() || structure.getCardinalityMax()==-1)
						transition = new TransitionFromSet (idTransition, structure, nameTargetUID);
					else
						transition = new Transition (idTransition, structure, nameTargetUID);
					((OutputStructure)structure).insertTransition(transition);
					this.setTransitions.add(transition);
					return;
				}
				else 
					throw new UIDException (UIDException.NOT_EXISTING_STRUCTURE, 
					"There is no output structure item with this name");
			}
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertTransitionFromOutputStructureInStructureToAnotherUID (String idSourceState, String nameStructure, 
			String nameExternalStructure, String nameTargetUID, String idTransition){
		for (int i=0; i<this.setStates.size(); i++){
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)){
				Structure structure = state.getStructureInStructure (nameStructure,nameExternalStructure);
				if (structure instanceof OutputStructure){
					Transition transition;
					if (structure.getCardinalityMax()>structure.getCardinalityMin() || structure.getCardinalityMax()==-1)
						transition = new TransitionFromSet (idTransition, structure, nameTargetUID);
					else
						transition = new Transition (idTransition, structure, nameTargetUID);
					((OutputStructure)structure).insertTransition(transition);
					this.setTransitions.add(transition);
					return;
				}
				else 
					throw new UIDException (UIDException.NOT_EXISTING_STRUCTURE, 
					"There is no output structure item with this name");
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_STATE, 
				"There is no state with this id");
	}
	
	public void insertConditionInTransition (String idTransition, String condition){
		for (int i=0; i<this.setTransitions.size(); i++){
			Transition transition = this.setTransitions.elementAt(i);
			if (transition.getId().equals(idTransition)){
				transition.setCondition(condition);
				this.setTransitions.add(transition);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_TRANSITION, 
				"There is no transition with this id");
	}

	public void insertOptionInTransition (String idTransition, String option){
		for (int i=0; i<this.setTransitions.size(); i++){
			Transition transition = this.setTransitions.elementAt(i);
			if (transition.getId().equals(idTransition)){
				transition.setOption(option);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_TRANSITION, 
				"There is no transition with this id");
	}

	public void setNoReturnToTransition (String idTransition){
		for (int i=0; i<this.setTransitions.size(); i++){
			Transition transition = this.setTransitions.elementAt(i);
			if (transition.getId().equals(idTransition)){
				transition.setNoReturn(true);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_TRANSITION, 
				"There is no transition with this id");
	}

	public void setReturnToTransition (String idTransition){
		for (int i=0; i<this.setTransitions.size(); i++){
			Transition transition = this.setTransitions.elementAt(i);
			if (transition.getId().equals(idTransition)){
				transition.setNoReturn(false);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_TRANSITION, 
				"There is no transition with this id");
	}

	public void setNumberOfSelectedElements (String idTransition, int numberOfSelectedElements){
		for (int i=0; i<this.setTransitions.size(); i++){
			Transition transition = this.setTransitions.elementAt(i);
			if (transition.getId().equals(idTransition) && transition instanceof TransitionFromSet){
				((TransitionFromSet)transition).setNumberOfSelectedElements(numberOfSelectedElements);
				return;
			}	
		}
		throw new UIDException (UIDException.NOT_EXISTING_TRANSITION, 
				"There is no transition from a set with this id");
	}

	public InitialState getInitialState() {
		return initialState;
	}

	public Vector<AbstractState> getSetStates() {
		return setStates;
	}

	public void insertPrecondition (String condition){
		this.listPreconditions.add(new Precondition(condition));
	}

	public void insertPoscondition (String condition){
		this.listPosconditions.add(new Poscondition(condition));
	}

	public void insertTextualNote (String note){
		this.listTextualNotes.add(new TextualNote(note));
	}

	public Vector<Transition> getSetTransitions (){
		return this.setTransitions;
	}

	public List<Precondition> getPreconditions (){
		return this.listPreconditions;
	}

	public List<Poscondition> getPosconditions (){
		return this.listPosconditions;
	}

	public List<TextualNote> getTextualNotes (){
		return this.listTextualNotes;
	}

	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public Vector<String> getSourceUIDs() {
		return setSourceUIDs;
	}
	
	public void insertSourceUID(String sourceUID) {
		//Nao confere se o source existe, simplesmente adiciona
		for (int i = 0; i < this.setSourceUIDs.size(); i++) {
			String source = this.setSourceUIDs.elementAt(i);
			if (source.equals(sourceUID)) {
				throw new UIDException(UIDException.EXISTING_SOURCE_UID,
				"There is already a source with this id");
				}
			}
		this.setSourceUIDs.add(sourceUID);
	}
	
	// SUBSTATE
	public void insertSubstate(String idState, String idSubstate) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertSubstate(idSubstate);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTextInSubstate(String idState, String idSubstate,
			String idText, String text) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertTextInSubstate(idSubstate, idText, text);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void defineTextInSubstateAsOptional(String idState,
			String idSubstate, String idText) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.defineTextInSubstateAsOptional(idSubstate, idText);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputOptionalDataItemInSubstate(String idState,
			String idSubstate, InputOptionalDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputOptionalDataItemInSubstate(idSubstate,
						dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputDataItemInSubstate(String idState,
			String idSubstate, InputDataItem dataItem) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputDataItemInSubstate(idSubstate, dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");
	}

	public void insertInputORDataItemInSubstate(String idState,
			String idSubstate, InputORDataEntry oRdataEntry) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputORDataItemInSubstate(idSubstate, oRdataEntry);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");
	}

	public void insertInputXORDataItemInSubstate(String idState,
			String idSubstate, InputXORDataEntry XORdataEntry) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state
						.insertInputXORDataItemInSubstate(idSubstate,
								XORdataEntry);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputEnumeratedDataInSubstate(String idState,
			String idSubstate, InputEnumeratedData enumeratedData) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputEnumeratedDataInSubstate(idSubstate,
						enumeratedData);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertSelectionInInputEnumeratedDataInSubstate(String idState,
			String idSubstate, String nameEnumeratedData, int min, int max) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertSelectionInInputEnumeratedDataInSubstate(
						idSubstate, nameEnumeratedData, min, max);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");
	}

	public void insertOptionInInputEnumeratedDataInSubstate(String idState,
			String idSubstate, String nameEnumeratedData, String option) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertOptionInInputEnumeratedDataInSubstate(idSubstate,
						nameEnumeratedData, option);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputStructureInSubstate(String idState,
			String idSubstate, InputStructure structure) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputStructureInSubstate(idSubstate, structure);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputDataItemInStructureInSubstate(String idState,
			String idSubstate, String nameStructure, InputDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputDataItemInStructureInSubstate(idSubstate,
						nameStructure, dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertInputStructureInStructureInSubstate(String idState,
			String idSubstate, String nameStructure, InputStructure structure) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertInputStructureInStructureInSubstate(idSubstate,
						nameStructure, structure);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTransitionFromSubstateToState(String idSourceState,
			String idSubstate, String idTargetState, String idTransition) {

		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState != null && targetState != null) {
			Substate substate = sourceState.getSubState(idSubstate);
			Transition transition;
			transition = new Transition(idTransition, substate, targetState);
			substate.insertTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		} else
			throw new UIDException(UIDException.NOT_EXISTING_STATE,
					"There is no state with this id");

	}

	public void insertTransitionFromSubstateToAnotherUID(String idSourceState,
			String idSubstate, String nameTargetUID, String idTransition) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)) {
				Substate substate = state.getSubState(idSubstate);
				Transition transition;
				transition = new Transition(idTransition, substate,
						nameTargetUID);
				substate.insertTransition(transition);
				this.setTransitions.add(transition);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertOutputDataItemInSubstate(String idState,
			String idSubstate, OutputDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertOutputDataItemInSubstate(idSubstate, dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertOutputStructureInSubstate(String idState,
			String idSubstate, OutputStructure structure) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertOutputStructureInSubstate(idSubstate, structure);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertOutputDataItemInStructureInSubstate(String idState,
			String idSubstate, String nameStructure, OutputDataItem dataItem) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertOutputDataItemInStructureInSubstate(idSubstate,
						nameStructure, dataItem);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertOutputStructureInStructureInSubstate(String idState,
			String idSubstate, String nameStructure, OutputStructure structure) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idState)) {
				state.insertOutputStructureInStructureInSubstate(idSubstate,
						nameStructure, structure);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTransitionFromOutputDataItemInSubstateToState(
			String idSourceState, String idSubstate, String nameDataItem,
			String idTargetState, String idTransition) {

		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState != null && targetState != null) {
			OutputDataItem dataItem = sourceState.getOutputDataItemInSubstate(
					nameDataItem, idSubstate);
			Transition transition;
			if (dataItem.getCardinalityMax() == -1
					|| dataItem.getCardinalityMax() > dataItem
							.getCardinalityMin())
				transition = new TransitionFromSet(idTransition, dataItem,
						targetState);
			else
				transition = new Transition(idTransition, dataItem, targetState);
			dataItem.insertTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		} else
			throw new UIDException(UIDException.NOT_EXISTING_STATE,
					"There is no state with this id");

	}

	public void insertTransitionFromOutputDataItemInSubstateToAnotherUID(
			String idSourceState, String idSubstate, String nameDataItem,
			String nameTargetUID, String idTransition) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)) {
				OutputDataItem dataItem = state.getOutputDataItemInSubstate(
						nameDataItem, idSubstate);
				Transition transition;
				if (dataItem.getCardinalityMax() == -1
						|| dataItem.getCardinalityMax() > dataItem
								.getCardinalityMin())
					transition = new TransitionFromSet(idTransition, dataItem,
							nameTargetUID);
				else
					transition = new Transition(idTransition, dataItem,
							nameTargetUID);
				dataItem.insertTransition(transition);
				this.setTransitions.add(transition);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTransitionFromOutputStructureInSubstateToState(
			String idSourceState, String idSubstate, String nameStructure,
			String idTargetState, String idTransition) {

		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState != null && targetState != null) {
			OutputStructure structure = sourceState
					.getOutputStructureInSubstate(nameStructure, idSubstate);
			Transition transition;
			if (structure.getCardinalityMax() == -1
					|| structure.getCardinalityMax() > structure
							.getCardinalityMin())
				transition = new TransitionFromSet(idTransition, structure,
						targetState);
			else
				transition = new Transition(idTransition, structure,
						targetState);
			structure.insertTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		} else
			throw new UIDException(UIDException.NOT_EXISTING_STATE,
					"There is no state with this id");

	}

	public void insertTransitionFromOutputStructureInSubstateToAnotherUID(
			String idSourceState, String idSubstate, String nameStructure,
			String nameTargetUID, String idTransition) {

		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)) {
				OutputStructure structure = state.getOutputStructureInSubstate(
						nameStructure, idSubstate);
				Transition transition;
				if (structure.getCardinalityMax() == -1
						|| structure.getCardinalityMax() > structure
								.getCardinalityMin())
					transition = new TransitionFromSet(idTransition, structure,
							nameTargetUID);
				else
					transition = new Transition(idTransition, structure,
							nameTargetUID);
				structure.insertTransition(transition);
				this.setTransitions.add(transition);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTransitionFromOutputDataItemInStructureInSubstateToState(
			String idSourceState, String idSubstate, String nameStructure,
			String nameDataItem, String idTargetState, String idTransition) {
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState != null && targetState != null) {
			OutputDataItem dataItem = sourceState
					.getOutputDataItemInStructureInSubstate(nameDataItem,
							idSubstate, nameStructure);
			Transition transition;
			if (dataItem.getCardinalityMax() == -1
					|| dataItem.getCardinalityMax() > dataItem
							.getCardinalityMin())
				transition = new TransitionFromSet(idTransition, dataItem,
						targetState);
			else
				transition = new Transition(idTransition, dataItem, targetState);
			dataItem.insertTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		} else
			throw new UIDException(UIDException.NOT_EXISTING_STATE,
					"There is no state with this id");

	}

	public void insertTransitionFromOutputDataItemInStructureInSubstateToAnotherUID(
			String idSourceState, String idSubstate, String nameStructure,
			String nameDataItem, String nameTargetUID, String idTransition) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)) {
				OutputDataItem dataItem = state
						.getOutputDataItemInStructureInSubstate(nameDataItem,
								idSubstate, nameStructure);
				Transition transition;
				if (dataItem.getCardinalityMax() == -1
						|| dataItem.getCardinalityMax() > dataItem
								.getCardinalityMin())
					transition = new TransitionFromSet(idTransition, dataItem,
							nameTargetUID);
				else
					transition = new Transition(idTransition, dataItem,
							nameTargetUID);
				dataItem.insertTransition(transition);
				this.setTransitions.add(transition);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public void insertTransitionFromOutputStructureInStructureInSubstateToState(
			String idSourceState, String idSubstate, String nameStructure,
			String nameNewStructure, String idTargetState, String idTransition) {
		AbstractState sourceState = null;
		AbstractState targetState = null;
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState))
				sourceState = state;
			if (state.getId().equals(idTargetState))
				targetState = state;
		}
		if (sourceState != null && targetState != null) {
			OutputStructure structure = sourceState
					.getOutputStructureInStructureInSubstate(nameNewStructure,
							idSubstate, nameStructure);
			Transition transition;
			if (structure.getCardinalityMax() == -1
					|| structure.getCardinalityMax() > structure
							.getCardinalityMin())
				transition = new TransitionFromSet(idTransition, structure,
						targetState);
			else
				transition = new Transition(idTransition, structure,
						targetState);
			structure.insertTransition(transition);
			targetState.insertIncomingTransition(transition);
			this.setTransitions.add(transition);
		} else
			throw new UIDException(UIDException.NOT_EXISTING_STATE,
					"There is no state with this id");

	}

	public void insertTransitionFromOutputStructureInStructureInSubstateToAnotherUID(
			String idSourceState, String idSubstate, String nameStructure,
			String nameInternalStructure, String nameTargetUID,
			String idTransition) {
		for (int i = 0; i < this.setStates.size(); i++) {
			AbstractState state = this.setStates.elementAt(i);
			if (state.getId().equals(idSourceState)) {
				OutputStructure structure = state
						.getOutputStructureInStructureInSubstate(
								nameInternalStructure, idSubstate,
								nameStructure);
				Transition transition;
				if (structure.getCardinalityMax() == -1
						|| structure.getCardinalityMax() > structure
								.getCardinalityMin())
					transition = new TransitionFromSet(idTransition, structure,
							nameTargetUID);
				else
					transition = new Transition(idTransition, structure,
							nameTargetUID);
				structure.insertTransition(transition);
				this.setTransitions.add(transition);
				return;
			}
		}
		throw new UIDException(UIDException.NOT_EXISTING_STATE,
				"There is no state with this id");

	}

	public List<DataItem> getDataItemsOfAllStructures() {
		List<DataItem> dts = new ArrayList<DataItem>();
		for(AbstractState s: this.setStates){
			for(Structure str: s.getAllStructuresAndInternalStructures()){
				dts.addAll(str.getDataItems());
			}
		}
		return dts;
	}

	
	public List<DataItem> getDataItemsWithNoStructure() {
		//retorna os data items que no aparecem em nenhuma estrutura
		List<DataItem> dateItemsWithNoStructure = new ArrayList<DataItem>();
		List<DataItem> dateItemsInsideStructures = this.getDataItemsOfAllStructures();
		
		for(AbstractState s: this.setStates){
			List<DataItem> dataItems = s.getAllDataItemsWithNoStructures();
			for (DataItem dt : dataItems){
				boolean contains = false;
				for (DataItem dtis: dateItemsInsideStructures)
					if (dt.getName().equals(dtis.getName()))
						contains = true;
				if (!contains)
					dateItemsWithNoStructure.add(dt);
			}
		}
		return dateItemsWithNoStructure;
	}


	public List<InputEnumeratedData> getAllInputEnumeratedData() {
		//retorna os dados enumerados que aparecem no UID 
		List<InputEnumeratedData> enumeratedData= new ArrayList<InputEnumeratedData>();
		for(AbstractState s: this.setStates){
			enumeratedData.addAll(s.getAllInputEnumeratedData());
		}
		return enumeratedData;
	}

	
	public List<DataItem> getDataItemsOfStructure(String struct) {

//		//ANTIGO
//		List<String> dts = new ArrayList<String>();
//		for(AbstractState s: this.setStates){
//			for(Structure str: s.getAllStructuresAndInternalStructures()){
//				if(str.getName().equals(struct)){
//					
//				}
//			}
//		}

		List<DataItem> dts = new ArrayList<DataItem>();
		for(AbstractState s: this.setStates){
			for(Structure str: s.getAllStructuresAndInternalStructures()){
				if(str.getName().equals(struct)){
					dts = str.getDataItems();
				}
			}
		}
		return dts;
	}

	
}
